/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/* Copyright (c) 1999 Madge Networks Ltd
 *
 * Author: TEG (Madge)
 * 20/09/1999
 */
/* Please refer to the LICENSE file supplied with this source code */

#include "madgepci.h"
#include <stdlib.h>

#define PCI1B_DEVICE_ID                0x0001
#define PCIBM2_DEVICE_ID               0x0002
#define K2_DEVICE_ID                   0x0003
#define PCIBM1_DEVICE_ID               0x0004
/*                                     0x0005 is not used */
#define CARDBUS_DEVICE_ID              0x0006
#define PRESTO_DEVICE_ID               0x0007
#define PCI4_DEVICE_ID                 0x0009
#define PCI4_MK2_DEVICE_ID             0x000A
#define CARDBUS2_DEVICE_ID             0x000B

#define PCIBM2_SUBSYSTEM_ID            0x0002
#define CARDBUS_SUBSYSTEM_ID           0x0006
#define PRESTO_SUBSYSTEM_ID            0x0007 /* Applies to Presto 2 also. */
#define PCI3_SUBSYSTEM_ID              0x0003
#define CARDBUS2_SUBSYSTEM_ID          0x0008
#define PCI4_SUBSYSTEM_ID              0x0009
#define PCI4_MK2_SUBSYSTEM_ID          0x000A

#define PRESTO2_PCI_REVISION           0x01
#define PRESTO2000_PCI_REVISION        0x02

static mtok_card_id mtok_cards[] = {
#if 0
	/* Unsupported Adapters */
	{	"Madge Smart 16/4 PCI Ringnode",
		 PCI1B_DEVICE_ID,
		 0xFF,0xFFFF,0,
		 ADAPTER_TYPE_PCI1B,ADAPTER_SUBTYPE_PCI1B},
	{	"Madge Smart 16/4 PCI Ringnode Mk1",
		PCIBM1_DEVICE_ID,
		0xFF,0xFFFF,0,
		ADAPTER_TYPE_PCIBM1,ADAPTER_SUBTYPE_PCIBM1},
#endif
	/* Driver Supported Adapters */
	{ 	"Smart 16/4 PCI Ringnode Mk2",
		PCIBM2_DEVICE_ID, 
		0xFF, 0xFFFF, 1,
		ADAPTER_TYPE_PCIBM2, ADAPTER_SUBTYPE_PCIBM2},
	{ 	"Presto PCI",
		PRESTO_DEVICE_ID, 
		0xFF, PRESTO_SUBSYSTEM_ID, 1,
		ADAPTER_TYPE_KNOSSOS, ADAPTER_SUBTYPE_PRESTO},
	{ 	"Presto PCI Plus",
		K2_DEVICE_ID,
		PRESTO2_PCI_REVISION, PRESTO_SUBSYSTEM_ID,1,
		ADAPTER_TYPE_KNOSSOS, ADAPTER_SUBTYPE_PRESTO2},
	{	 "Presto PCI 2000",
		K2_DEVICE_ID,
		PRESTO2000_PCI_REVISION, PRESTO_SUBSYSTEM_ID,1,
		ADAPTER_TYPE_KNOSSOS, ADAPTER_SUBTYPE_PRESTO2000},
	{ 	"Smart 16/4 PCI Ringnode Mk3",
		K2_DEVICE_ID, 
		0xFF, PCI3_SUBSYSTEM_ID,1,
		ADAPTER_TYPE_KNOSSOS, ADAPTER_SUBTYPE_PCI3},
	{	"Smart 100/16/4 PCI-HS Ringnode",
		PCI4_DEVICE_ID,
		0xFF, 0xFFFF,1,
		ADAPTER_TYPE_KNOSSOS, ADAPTER_SUBTYPE_PCI4},
	{	"Smart 100/16/4 PCI Ringnode",
		PCI4_MK2_DEVICE_ID,
		0xFF, 0xFFFF,1,
		ADAPTER_TYPE_KNOSSOS, ADAPTER_SUBTYPE_PCI4_MK2},
	{	"Smart 16/4 PCMCIA",
		0,
		0xFF, 0xFFFF,1,
		ADAPTER_TYPE_PCMCIA, ADAPTER_SUBTYPE_PCMCIA},
	{	"Smart 16/4 PCMCIA",
		0,
		0xFF, 0xFFFF,1,
		ADAPTER_TYPE_PCMCIA, ADAPTER_SUBTYPE_PCMCIA_2},
	{	"16/4 CardBus Adapter Mk 2",
		CARDBUS2_DEVICE_ID,
		0xFF, 0xFFFF,1,
		ADAPTER_TYPE_KNOSSOS_CARDBUS, ADAPTER_SUBTYPE_CARDBUS2},
	{   "Unknown Madge Token Ring Adapter",
	    0xFFFF,
	    0xFF, 0xFFFF,1,
	    0xFFFF,0xFFFF}
};

#define NUM_ADAPTERS (sizeof(mtok_cards)/sizeof(mtok_card_id))

mtok_card_id * mtok_pci_type_to_cardid(int type,int subtype)
{
	int i;
	for(i=0;i<NUM_ADAPTERS;i++)
	{
		if (mtok_cards[i].adapter_type == type &&
			mtok_cards[i].adapter_subtype == subtype)
			return &mtok_cards[i];
	}
	return NULL;
}

mtok_card_id * mtok_pci_to_cardid(int ven,int dev,int sven,int sdev,int rev)
{
	int i;
	for(i=0;i<NUM_ADAPTERS;i++)
	{
		if (dev != mtok_cards[i].deviceid)
			continue;
			
		/* Check Sub System ID if its relevent */
			
		if (mtok_cards[i].subsystemid != 0xffff &&
			mtok_cards[i].subsystemid != sdev)
				continue;
				
		/*
         * If the card looks like an Abyss, it may be one of the early
         * CardBus cards which erroneously had a device ID of 0002h (the
         * same as the Abyss). They can be distinguished by looking at
         * the subsystem adapter ID, which is correctly 0006h (as the
         * device ID should have been).
         */
		if (mtok_cards[i].adapter_subtype == ADAPTER_SUBTYPE_PCIBM2 &&
			sdev == CARDBUS_SUBSYSTEM_ID)
			continue;

		if (mtok_cards[i].revision != 0xFF &&
			mtok_cards[i].revision != rev)
			continue;

		return &mtok_cards[i];
	}
	return NULL;
}

