/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

#ifndef __MADGEPCI_H
#define __MADGEPCI_H

#include <asm/types.h>
#include "mdgioctl.h"

#define PCI_BUS(b)	((b & 0xFF00) >> 8)
#ifndef PCI_FUNC
#define PCI_DEVFN(slot,func)    ((((slot) & 0x1f) << 3) | ((func) & 0x07))
#define PCI_SLOT(devfn)         (((devfn) >> 3) & 0x1f)
#define PCI_FUNC(devfn)         ((devfn) & 0x07)
#endif


typedef struct {
	char *	description;
	__u16 	deviceid;
	__u8	revision;
	__u16	subsystemid;
	__u8	supported;
	__u16 	adapter_type;
	__u16	adapter_subtype;
} mtok_card_id;

typedef unsigned char u8;

typedef struct _pci_device {
	struct _pci_device * next;
	struct _pci_device * prev;
	mtok_card_id * cardid;
	MTOK_IOCTL_INFO	info;
	MTOK_IOCTL_STATS stats;

#if 0
	int busdevfn;
	int manfid;
	int devid;
	int irq;
	int baseaddr;
	int type;
	int subtype;
	unsigned char bia[6];
	unsigned char laa[6];
#endif
	
	int sw_running;
	int sw_version;
	char dev_name[8];
	
} pci_device;

pci_device * madge_pci_find_busdevfn(int busdevfn);
void madge_pci_append(pci_device *dev);
pci_device * madge_pci_new_device(int busdevfn);
int madge_pci_get_old_running_info();
pci_device * madge_pci_get_list();
int madge_pci_get_adapters_v22();
int madge_pci_get_new_running_info();


mtok_card_id * mtok_pci_type_to_cardid(int type,int subtype);
mtok_card_id * mtok_pci_to_cardid(int ven,int dev,int sven,int sdev,int rev);


#define ADAPTER_TYPE_PCMCIA	   7
#define ADAPTER_TYPE_PCI1B     8
#define ADAPTER_TYPE_PCIBM1    9
#define ADAPTER_TYPE_PCIBM2    10
#define ADAPTER_TYPE_KNOSSOS   11
#define ADAPTER_TYPE_CARDBUS   12
#define ADAPTER_TYPE_KNOSSOS_CARDBUS 17

#define ADAPTER_SUBTYPE_PCMCIA		18
#define ADAPTER_SUBTYPE_PCMCIA_2	19
#define ADAPTER_SUBTYPE_PCI1B		20
#define ADAPTER_SUBTYPE_PCIBM1		21
#define ADAPTER_SUBTYPE_PCIBM2		22
#define ADAPTER_SUBTYPE_PRESTO		23
#define ADAPTER_SUBTYPE_PCI3		24
#define ADAPTER_SUBTYPE_PRESTO2		26
#define ADAPTER_SUBTYPE_PRESTO2000 	27
#define ADAPTER_SUBTYPE_CARDBUS2	28
#define ADAPTER_SUBTYPE_PCI4		29
#define ADAPTER_SUBTYPE_PCI4_MK2	30


#endif
