/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/*
 * Copyright (c) 1999 Madge Networks Ltd
 *
 * Author: TEG (Madge)
 * 230/09/1999
 */
/* Please refer to the LICENSE file supplied with this source code */

#include "driver.h"
#include <sys/stat.h>
#include <unistd.h>

#include "pci.h"


#define PROC_PCI_PREFIX 		"/proc/bus/pci"
#define NEW_PCI_DEVICES_FILE	"/proc/bus/pci/devices"

#define OLD_PCI_DEVICES_FILE	"/proc/pci"

RETCODE_T register_pci(P_DRIVER_T dds_ptr,WORD_T pci_number,PCI_HANDLE_T *fd)
{
	char Filename[128];
	struct stat StatBuffer;
	static PCIOK = 2;

	if (PCIOK != TRUE && PCIOK != FALSE)
	{
		if (stat(NEW_PCI_DEVICES_FILE,&StatBuffer) < 0)
		{
			PCIOK = FALSE;
			return NO_PCI_BUSES;
		} else {
			PCIOK = TRUE;
		}
	}

	if (PCIOK==FALSE)
		return NO_PCI_BUSES;
		
	sprintf(Filename,"%s/%02x/%02x.%01x",PROC_PCI_PREFIX,
										PCI_BUS_NUMBER(pci_number),
										PCI_DEVICE_NUMBER(pci_number),
										PCI_FUNCTION_NUMBER(pci_number) );



//	printf("register_pci: %s\n",Filename);
										
	if ((*fd = open(Filename,0)) < 0)
		return NO_PCI_CONFIGURATION_SPACE;

//	printf("Succeeded\n");

	return SUCCESS;	
}

VOID_T unregister_pci(P_DRIVER_T dds_ptr,WORD_T pci_number,PCI_HANDLE_T fd)
{
//	printf("unregister_pci\n"); 

	if(fd >= 0)
	{
//		printf("Closing proc file\n");	
		close(fd);
	}
}	

BYTE_T pci_readb(P_DRIVER_T dds_ptr,PCI_HANDLE_T fd,UINT_T offset)
{
	BYTE_T Value;
	lseek(fd,offset,SEEK_SET);
	read(fd,&Value,sizeof(BYTE_T));
//	printf("Offset %d Value %X\n",offset,Value);
	return Value;
}


WORD_T pci_readw(P_DRIVER_T dds_ptr,PCI_HANDLE_T fd,UINT_T offset)
{
	WORD_T Value;
	lseek(fd,offset,SEEK_SET);
	read(fd,&Value,sizeof(WORD_T));
//	printf("Offset %d Value %X\n",offset,Value);
	return Value;
}

DWORD_T pci_readd(P_DRIVER_T dds_ptr,PCI_HANDLE_T fd,UINT_T offset)
{
	DWORD_T Value;
	lseek(fd,offset,SEEK_SET);
	read(fd,&Value,sizeof(DWORD_T));
//	printf("readd offset: %d value: %X\n",offset,Value);
	return Value;
}

VOID_T pci_writew(P_DRIVER_T dds_ptr,PCI_HANDLE_T fd,UINT_T offset,WORD_T Value)
{
	lseek(fd,offset,SEEK_SET);
	write(fd,&Value,sizeof(WORD_T));
//	printf("Offset %d Value %X\n",offset,Value);
}

VOID_T pci_writeb(P_DRIVER_T dds_ptr,PCI_HANDLE_T fd,UINT_T offset,BYTE_T Value)
{
	lseek(fd,offset,SEEK_SET);
	write(fd,&Value,sizeof(BYTE_T));
//	printf("Offset %d Value %X\n",offset,Value);
}

VOID_T pci_writed(P_DRIVER_T dds_ptr,PCI_HANDLE_T fd,UINT_T offset,DWORD_T Value)
{
	lseek(fd,offset,SEEK_SET);
	write(fd,&Value,sizeof(DWORD_T));
//	printf("Offset %d Value %X\n",offset,Value);
}
